"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isValidValue = exports.CUSTOM_BREADCRUMB_PAGE_KEY = exports.INIT_DB_CHECK_STATE = exports.JSON_FORM_TYPE = exports.RUNNING_STATE = exports.DOTENV = exports.MQTT_STATE = exports.MQTT_CONFIG = exports.API_RETURN_CODE = exports.DKAPI_ENDPOINT = exports.API_HOST = exports.API_CONFIG = exports.HTTP_HEADER_VALUE = exports.HTTP_METHOD = exports.API_REQUEST_STATE = exports.LOAD_STATE = exports.SUPPORT_LAYOUT_TYPE_LIST = exports.SUPPORT_LAYOUT_TYPE = exports.SUPPORT_THEME_CODE_LIST = exports.SUPPORT_THEME = exports.SUPPORT_LOCALE_CODE_LIST = exports.SUPPORT_LOCALE = exports.TABLE_PAGE_SIZES = exports.DRAWER_OPEN_TYPE = exports.USER_ROLE = exports.SIMPLE_CONFIG_TYPE = exports.TERMINAL = exports.STATUS = exports.YES_OR_NO = exports.GENDER = void 0;
require("dayjs/locale/ko");
require("dayjs/locale/en");
require("dayjs/locale/zh-cn");
var GENDER = {
    MALE: 1,
    FEMALE: 2,
    UNKNOWN: 3,
    NO_COMMENT: 4,
};
exports.GENDER = GENDER;
var YES_OR_NO = {
    YES: 1,
    NO: 2,
};
exports.YES_OR_NO = YES_OR_NO;
var STATUS = {
    ENABLE: 1,
    PAUSE: 2,
    DISABLE: 3,
};
exports.STATUS = STATUS;
var TERMINAL = {
    WEB: 1,
    ANDROID: 2,
    IOS: 3,
    SERVER: 100,
};
exports.TERMINAL = TERMINAL;
var SIMPLE_CONFIG_TYPE = {
    REACT_PAGE: {
        key: 1,
        text: 'setting.simpleConfig.reactPage',
    },
    TEMPLATE_GROUP: {
        key: 2,
        text: 'setting.simpleConfig.templateGroup',
    },
    ANTD_ICON: {
        key: 3,
        text: 'setting.simpleConfig.antdIcon',
    },
    LANG_CODE: {
        key: 4,
        text: 'setting.simpleConfig.langCode',
    },
};
exports.SIMPLE_CONFIG_TYPE = SIMPLE_CONFIG_TYPE;
var USER_ROLE = {
    ROOT: {
        key: 1,
        label: 'overall.userRole.root',
    },
    NORMAL1: {
        key: 100,
        label: 'overall.userRole.normal1',
    },
};
exports.USER_ROLE = USER_ROLE;
var DRAWER_OPEN_TYPE = {
    OPEN: 1,
    OPEN_NEW: 2,
    OPEN_MOD: 3,
    CLOSE: 100,
};
exports.DRAWER_OPEN_TYPE = DRAWER_OPEN_TYPE;
var TABLE_PAGE_SIZES = [15, 30, 50, 100];
exports.TABLE_PAGE_SIZES = TABLE_PAGE_SIZES;
if (process.env.NODE_ENV_TYPE) {
    TABLE_PAGE_SIZES.unshift(2);
}
var SUPPORT_LOCALE = {
    ko_KR: 'ko_KR',
    en_US: 'en_US',
    zh_CN: 'zh_CN',
};
exports.SUPPORT_LOCALE = SUPPORT_LOCALE;
var supportLocaleList = Object.keys(SUPPORT_LOCALE);
var SUPPORT_LOCALE_CODE_LIST = [];
exports.SUPPORT_LOCALE_CODE_LIST = SUPPORT_LOCALE_CODE_LIST;
for (var _i = 0, supportLocaleList_1 = supportLocaleList; _i < supportLocaleList_1.length; _i++) {
    var row = supportLocaleList_1[_i];
    SUPPORT_LOCALE_CODE_LIST.push(SUPPORT_LOCALE[row]);
}
var SUPPORT_THEME = {
    CLASSIC: 'classic',
    DARK: 'dark',
};
exports.SUPPORT_THEME = SUPPORT_THEME;
var supportThemeList = Object.keys(SUPPORT_THEME);
var SUPPORT_THEME_CODE_LIST = [];
exports.SUPPORT_THEME_CODE_LIST = SUPPORT_THEME_CODE_LIST;
for (var _a = 0, supportThemeList_1 = supportThemeList; _a < supportThemeList_1.length; _a++) {
    var row = supportThemeList_1[_a];
    SUPPORT_THEME_CODE_LIST.push(SUPPORT_THEME[row]);
}
var SUPPORT_LAYOUT_TYPE = {
    A: 'a',
    B: 'b',
    C: 'c',
    D: 'd',
    E: 'e',
    F: 'f',
};
exports.SUPPORT_LAYOUT_TYPE = SUPPORT_LAYOUT_TYPE;
var supportLayoutTypeList = Object.keys(SUPPORT_LAYOUT_TYPE);
var SUPPORT_LAYOUT_TYPE_LIST = [];
exports.SUPPORT_LAYOUT_TYPE_LIST = SUPPORT_LAYOUT_TYPE_LIST;
for (var _b = 0, supportLayoutTypeList_1 = supportLayoutTypeList; _b < supportLayoutTypeList_1.length; _b++) {
    var row = supportLayoutTypeList_1[_b];
    SUPPORT_LAYOUT_TYPE_LIST.push(SUPPORT_LAYOUT_TYPE[row]);
}
var LOAD_STATE = {
    INIT: 1,
    LOADING: 2,
    COMPLETE: 3,
};
exports.LOAD_STATE = LOAD_STATE;
var API_REQUEST_STATE = {
    INIT: 1,
    PENDING: 2,
    FULFILLED: 3,
    REJECTED: 4,
};
exports.API_REQUEST_STATE = API_REQUEST_STATE;
var HTTP_HEADER_VALUE = {
    JSON: 'application/json',
};
exports.HTTP_HEADER_VALUE = HTTP_HEADER_VALUE;
var HTTP_METHOD = {
    GET: 'GET',
    POST: 'POST',
    PUT: 'PUT',
    DELETE: 'DELETE',
};
exports.HTTP_METHOD = HTTP_METHOD;
var API_CONFIG = {
    KEY: process.env.REACT_APP_API_KEY || '',
    SECRET: process.env.REACT_APP_API_SECRET || '',
    HOST: process.env.REACT_APP_API_HOST || '',
    PORT: process.env.REACT_APP_API_PORT || '',
    TIMEOUT: Number(process.env.REACT_APP_API_TIMEOUT || '30000'),
};
exports.API_CONFIG = API_CONFIG;
var API_HOST = (API_CONFIG.PORT ? "".concat(API_CONFIG.HOST, ":").concat(API_CONFIG.PORT) : API_CONFIG.HOST);
exports.API_HOST = API_HOST;
var DKAPI_CORE_PREFIX = '/v1/admin';
var DKAPI_ENDPOINT = {
    INIT_CHECK: "".concat(DKAPI_CORE_PREFIX, "/init/db/check"),
    INIT_TABLE: "".concat(DKAPI_CORE_PREFIX, "/init/db/table"),
    INIT_DATA: "".concat(DKAPI_CORE_PREFIX, "/init/db/data"),
    LOGIN: "".concat(DKAPI_CORE_PREFIX, "/user/login"),
    LOGOUT: "".concat(DKAPI_CORE_PREFIX, "/user/logout"),
    ACCESS_TOKEN_CONTINUE: "".concat(DKAPI_CORE_PREFIX, "/user/access/token/continue"),
    ROLE_LIST: "".concat(DKAPI_CORE_PREFIX, "/role/list"),
    MENU_LIST: "".concat(DKAPI_CORE_PREFIX, "/menu/list"),
    MENU_DEL: "".concat(DKAPI_CORE_PREFIX, "/menu/remove"),
    MENU_ADD: "".concat(DKAPI_CORE_PREFIX, "/menu"),
    MENU_MOD: "".concat(DKAPI_CORE_PREFIX, "/menu"),
    MENU_INFO: "".concat(DKAPI_CORE_PREFIX, "/menu"),
    MENU_CANGE_ORDER: "".concat(DKAPI_CORE_PREFIX, "/menu/lorder"),
    SIMPLE_CONFIG_LIST: "".concat(DKAPI_CORE_PREFIX, "/etc/config/list"),
    SIMPLE_CONFIG_DEL: "".concat(DKAPI_CORE_PREFIX, "/etc/config/remove"),
    SIMPLE_CONFIG_ADD: "".concat(DKAPI_CORE_PREFIX, "/etc/config"),
    SIMPLE_CONFIG_MOD: "".concat(DKAPI_CORE_PREFIX, "/etc/config"),
    SIMPLE_CONFIG_INFO: "".concat(DKAPI_CORE_PREFIX, "/etc/config"),
    CONFIRM_IP_LIST: "".concat(DKAPI_CORE_PREFIX, "/etc/allow/deny/cidr/list"),
    CONFIRM_IP_DEL: "".concat(DKAPI_CORE_PREFIX, "/etc/allow/deny/cidr/remove"),
    CONFIRM_IP_ADD: "".concat(DKAPI_CORE_PREFIX, "/etc/allow/deny/cidr"),
    CONFIRM_IP_MOD: "".concat(DKAPI_CORE_PREFIX, "/etc/allow/deny/cidr"),
    CONFIRM_IP_INFO: "".concat(DKAPI_CORE_PREFIX, "/etc/allow/deny/cidr"),
    TMPL_LIST: "".concat(DKAPI_CORE_PREFIX, "/template/list"),
    TMPL_DEL: "".concat(DKAPI_CORE_PREFIX, "/template/remove"),
    TMPL_ADD: "".concat(DKAPI_CORE_PREFIX, "/template"),
    TMPL_MOD: "".concat(DKAPI_CORE_PREFIX, "/template"),
    TMPL_INFO: "".concat(DKAPI_CORE_PREFIX, "/template"),
    FILE_UPLOAD: "".concat(DKAPI_CORE_PREFIX, "/file/upload"),
    DOC_LIST: "".concat(DKAPI_CORE_PREFIX, "/board/document/list"),
    DOC_INFO: "".concat(DKAPI_CORE_PREFIX, "/board/document"),
    DOC_ADD: "".concat(DKAPI_CORE_PREFIX, "/board/document"),
    DOC_MOD: "".concat(DKAPI_CORE_PREFIX, "/board/document"),
    DOC_DELETE: "".concat(DKAPI_CORE_PREFIX, "/board/document/remove"),
};
exports.DKAPI_ENDPOINT = DKAPI_ENDPOINT;
var API_RETURN_CODE = {
    SUCCESS: 'S000001',
    INVALID_AUTH: 'E000004',
};
exports.API_RETURN_CODE = API_RETURN_CODE;
var MQTT_CONFIG = {
    PROTOCOL: "".concat(process.env.REACT_APP_MQTT_PROTOCOL),
    HOST: "".concat(process.env.REACT_APP_MQTT_HOST),
    PORT: Number(process.env.REACT_APP_MQTT_PORT),
    KEEP_ALIVE: Number(process.env.REACT_APP_MQTT_KEEP_ALIVE),
    RECONNECT_PERIOD: Number(process.env.REACT_APP_MQTT_RECONNECT_PERIOD),
    QOS: Number(process.env.REACT_APP_MQTT_QOS),
    USER_ID: "".concat(process.env.REACT_APP_MQTT_USER_ID),
    PASSWORD: "".concat(process.env.REACT_APP_MQTT_PASSWORD),
    CLIENT_ID: "".concat(process.env.REACT_APP_MQTT_CLIENT_ID),
    RECV_MAX_MSG_COUNT: Number(process.env.REACT_APP_MQTT_RECV_MAX_MSG_COUNT),
    RECV_DELAY: Number(process.env.REACT_APP_MQTT_RECV_DELAY),
    RECV_BUFFER_SIZE: Number(process.env.REACT_APP_MQTT_RECV_BUFFER_SIZE),
    AUTO_CONNECT: "".concat(process.env.REACT_APP_MQTT_AUTO_CONNECT).toLowerCase() === 'true',
    AUTO_SUBSCRIBE_TOPICS: JSON.parse("".concat(process.env.REACT_APP_MQTT_AUTO_SUBSCRIBE_TOPICS)),
};
exports.MQTT_CONFIG = MQTT_CONFIG;
var MQTT_STATE = {
    INIT: 1,
    CONNECTING: 2,
    RECONNECTING: 3,
    CONNECTED: 4,
    FAILED: 5,
    DISCONNECT: 6,
    DISCONNECT_FORCE: 7,
};
exports.MQTT_STATE = MQTT_STATE;
var appVersion = (process.env.NODE_ENV_TYPE ? "".concat(process.env.APP_VERSION, ".").concat(process.env.NODE_ENV, ".").concat(process.env.NODE_ENV_TYPE) : "".concat(process.env.APP_VERSION, ".").concat(process.env.NODE_ENV));
var DOTENV = {
    TIME_ZONE: "".concat(process.env.REACT_APP_TIME_ZONE),
    URL_PREFIX: "".concat(process.env.REACT_APP_URL_PREFIX),
    VERSION: appVersion,
    INIT_DB_DATA_AUTH_APP_KEY: "".concat(process.env.REACT_APP_INIT_DB_DATA_AUTH_APP_KEY),
    INIT_DB_DATA_AUTH_SIGNATURE_KEY: "".concat(process.env.REACT_APP_INIT_DB_DATA_AUTH_SIGNATURE_KEY),
    KEY_AES_SECRET: "".concat(process.env.REACT_APP_KEY_AES_SECRET),
    KEY_API_KEY_SECRET: "".concat(process.env.REACT_APP_KEY_API_KEY_SECRET),
    KEY_USER: "".concat(process.env.REACT_APP_KEY_USER),
    KEY_CONFIG: "".concat(process.env.REACT_APP_KEY_CONFIG),
    KEY_MQTT: "".concat(process.env.REACT_APP_KEY_MQTT),
    KEY_SIDEBAR_MENU_TREE: "".concat(process.env.REACT_APP_KEY_SIDEBAR_MENU_TREE),
    KEY_SIDEBAR_MENU_MAP: "".concat(process.env.REACT_APP_KEY_SIDEBAR_MENU_MAP),
    KEY_LAST_PAGE: "".concat(process.env.REACT_APP_KEY_LAST_PAGE),
    URL_PATH_DB_DATA_INIT: "".concat(process.env.REACT_APP_URL_PATH_DB_DATA_INIT),
    URL_PATH_LOGIN: "".concat(process.env.REACT_APP_URL_PATH_LOGIN),
    URL_PATH_NO_AUTH: "".concat(process.env.REACT_APP_URL_PATH_NO_AUTH),
    NO_AUTH_AUTO_SEC: Number("".concat(process.env.REACT_APP_NO_AUTH_AUTO_SEC)),
    FILE_KEY: "".concat(process.env.REACT_APP_FILE_KEY),
};
exports.DOTENV = DOTENV;
var RUNNING_STATE = {
    INIT: 1,
    RUNNING: 2,
    STOP: 3,
};
exports.RUNNING_STATE = RUNNING_STATE;
var JSON_FORM_TYPE = {
    NORMAL_EDITOR: 1,
    NORMAL_VIEW: 2,
    MENU: 3,
    TEMPLATE: 4,
};
exports.JSON_FORM_TYPE = JSON_FORM_TYPE;
var CUSTOM_BREADCRUMB_PAGE_KEY = '3061bf0e4b595c6a8618406b61737378';
exports.CUSTOM_BREADCRUMB_PAGE_KEY = CUSTOM_BREADCRUMB_PAGE_KEY;
var INIT_DB_CHECK_STATE = {
    PREV: 1,
    FAIL: 2,
};
exports.INIT_DB_CHECK_STATE = INIT_DB_CHECK_STATE;
var isValidValue = function (enumType, checkValue) {
    var keys = Object.keys(enumType);
    for (var i = 0, len = keys.length; i < len; i += 1) {
        if (enumType[keys[i]] === checkValue) {
            return true;
        }
    }
    return false;
};
exports.isValidValue = isValidValue;
