"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var antd_1 = require("antd");
var react_router_dom_1 = require("react-router-dom");
var DkValues_1 = require("../DkValues");
var CkUtils_1 = __importDefault(require("../utils/CkUtils"));
var withRestApi = function (Component) { return function (props) {
    var navigate = (0, react_router_dom_1.useNavigate)();
    var location = (0, react_router_dom_1.useLocation)();
    var params = (0, react_router_dom_1.useParams)();
    var nprops = __assign(__assign({}, props), params);
    var isApiError = function (resp, intl, errMsgId, movePage) {
        var msgId = errMsgId || 'overall.apiFailed';
        if (!resp || !resp.payload || !resp.payload.ckError) {
            antd_1.message.error(intl.formatMessage({ id: msgId }, { p1: '' }));
            return true;
        }
        if (resp.payload.ckError !== DkValues_1.API_RETURN_CODE.SUCCESS) {
            antd_1.message.error(intl.formatMessage({ id: msgId }, { p1: resp.payload.ckMessage }));
            if (resp.payload.ckError === DkValues_1.API_RETURN_CODE.INVALID_AUTH) {
                if (movePage) {
                    movePage(CkUtils_1.default.getSvcURLPath(DkValues_1.DOTENV.URL_PATH_NO_AUTH), navigate);
                }
                else if (nprops.movePage) {
                    nprops.movePage(CkUtils_1.default.getSvcURLPath(DkValues_1.DOTENV.URL_PATH_NO_AUTH), navigate);
                }
                else {
                    console.error('not set movePage function.');
                }
            }
            return true;
        }
        return false;
    };
    return react_1.default.createElement(Component, __assign({}, nprops, { navigate: navigate, location: location, isApiError: isApiError }));
}; };
exports.default = withRestApi;
