"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var uuid = __importStar(require("uuid"));
var DkValues_1 = require("../DkValues");
var CkStorage_1 = __importDefault(require("./CkStorage"));
var CkUtils = (function () {
    function CkUtils() {
    }
    CkUtils.getUUID = function (isContainDash) {
        if (isContainDash === true) {
            return uuid.v1();
        }
        return uuid.v1().replace(/-/gi, '');
    };
    CkUtils.getUUIDV4 = function (isContainDash) {
        if (isContainDash === true) {
            return uuid.v4();
        }
        return uuid.v4().replace(/-/gi, '');
    };
    CkUtils.getUUIDV5 = function (name, nameSpace, isContainDash) {
        var _namespace = nameSpace || CkUtils.getUUIDV4(true);
        if (isContainDash === true) {
            return uuid.v5(name, _namespace);
        }
        return uuid.v5(name, _namespace).replace(/-/gi, '');
    };
    CkUtils.getSvcURLPath = function (path, params, isUpdateLastPage) {
        var retPath = "".concat(DkValues_1.DOTENV.URL_PREFIX).concat(path).replace(/\/\//gi, '/');
        if (params && Object.keys(params).length > 0) {
            retPath = CkUtils.getReplacedURLPath(retPath, params);
        }
        if (isUpdateLastPage) {
            var pageInfo = {
                urlPath: retPath,
                tm: Date.now(),
            };
            CkStorage_1.default.save(DkValues_1.DOTENV.KEY_LAST_PAGE, pageInfo);
        }
        return retPath;
    };
    CkUtils.getReplacedURLPath = function (urlPath, replaceValues) {
        if (!urlPath) {
            return undefined;
        }
        if (!replaceValues) {
            return urlPath;
        }
        var keys = Object.keys(replaceValues);
        var _urlPath = urlPath;
        var isHas = _urlPath.indexOf(':');
        if (isHas) {
            for (var _i = 0, keys_1 = keys; _i < keys_1.length; _i++) {
                var key = keys_1[_i];
                _urlPath = _urlPath.replace(":".concat(key), replaceValues[key]);
            }
        }
        return _urlPath;
    };
    CkUtils.getApplyIpByCIDR = function (cidr, isPermitAsterica) {
        if (!cidr || !cidr.trim()) {
            console.log("no cidr value [".concat(cidr, "]"));
            return null;
        }
        if (isPermitAsterica && cidr.trim() === '*') {
            return { startIP: '*', endIP: '*' };
        }
        var cidrs = cidr.trim().split('/');
        if (cidrs.length !== 2) {
            console.log("invalid cidr value [".concat(cidr, "]"));
            return null;
        }
        var flagNum = Number(cidrs[1]);
        if (Number.isNaN(flagNum) || flagNum > 32 || flagNum < 0) {
            console.log("invalid cidr ip flag [".concat(cidrs[1], "]"));
            return null;
        }
        var strCIDRIP = cidrs[0].split('.');
        if (strCIDRIP.length !== 4) {
            console.log("invalid cidr ip [".concat(cidrs[0], "]"));
            return null;
        }
        if (flagNum === 32) {
            return { startIP: "".concat(cidrs[0]), endIP: "".concat(cidrs[0]) };
        }
        if (flagNum === 24) {
            return { startIP: "".concat(strCIDRIP[0], ".").concat(strCIDRIP[1], ".").concat(strCIDRIP[2], ".0"), endIP: "".concat(strCIDRIP[0], ".").concat(strCIDRIP[1], ".").concat(strCIDRIP[2], ".255") };
        }
        if (flagNum === 16) {
            return { startIP: "".concat(strCIDRIP[0], ".").concat(strCIDRIP[1], ".0.0"), endIP: "".concat(strCIDRIP[0], ".").concat(strCIDRIP[1], ".255.255") };
        }
        if (flagNum === 8) {
            return { startIP: "".concat(strCIDRIP[0], ".0.0.0"), endIP: "".concat(strCIDRIP[0], ".255.255.255") };
        }
        if (flagNum === 0) {
            return { startIP: '0.0.0.0', endIP: '255.255.255.255' };
        }
        var cidrIps = [];
        for (var _i = 0, strCIDRIP_1 = strCIDRIP; _i < strCIDRIP_1.length; _i++) {
            var row = strCIDRIP_1[_i];
            cidrIps.push(Number(row));
        }
        var strFlag = '';
        for (var i = 0, flag = flagNum; i < flag; i += 1) {
            strFlag = "".concat(strFlag, "1");
        }
        for (var i = 0, rest = 32 - flagNum; i < rest; i += 1) {
            strFlag = "".concat(strFlag, "0");
        }
        var cidrFlags = [
            parseInt(strFlag.substring(0, 8), 2),
            parseInt(strFlag.substring(8, 16), 2),
            parseInt(strFlag.substring(16, 24), 2),
            parseInt(strFlag.substring(24), 2),
        ];
        for (var i = 0; i < 4; i += 1) {
            cidrIps[i] &= cidrFlags[i];
        }
        var ret = { startIP: '', endIP: '' };
        if (flagNum > 24) {
            for (var i = 0; i <= 255; i += 1) {
                if ((i & cidrFlags[3]) === cidrIps[3]) {
                    if (ret.startIP) {
                        ret.endIP = "".concat(strCIDRIP[0], ".").concat(strCIDRIP[1], ".").concat(strCIDRIP[2], ".").concat(i);
                    }
                    else {
                        ret.startIP = "".concat(strCIDRIP[0], ".").concat(strCIDRIP[1], ".").concat(strCIDRIP[2], ".").concat(i);
                    }
                }
            }
        }
        else if (flagNum > 16) {
            for (var i = 0; i <= 255; i += 1) {
                if ((i & cidrFlags[2]) === cidrIps[2]) {
                    if (ret.startIP) {
                        ret.endIP = "".concat(strCIDRIP[0], ".").concat(strCIDRIP[1], ".").concat(i, ".255");
                    }
                    else {
                        ret.startIP = "".concat(strCIDRIP[0], ".").concat(strCIDRIP[1], ".").concat(i, ".0");
                    }
                }
            }
        }
        else if (flagNum > 8) {
            for (var i = 0; i <= 255; i += 1) {
                if ((i & cidrFlags[1]) === cidrIps[1]) {
                    if (ret.startIP) {
                        ret.endIP = "".concat(strCIDRIP[0], ".").concat(i, ".255.255");
                    }
                    else {
                        ret.startIP = "".concat(strCIDRIP[0], ".").concat(i, ".0.0");
                    }
                }
            }
        }
        else {
            for (var i = 0; i <= 255; i += 1) {
                if ((i & cidrFlags[0]) === cidrIps[0]) {
                    if (ret.startIP) {
                        ret.endIP = "".concat(i, ".255.255.255");
                    }
                    else {
                        ret.startIP = "".concat(i, ".0.0.0");
                    }
                }
            }
        }
        return ret;
    };
    CkUtils.errorResponse = function (apiKind, thunkAPI, err) {
        var _a;
        if (err && err.response) {
            console.warn("[rest-api] ".concat(apiKind, " failed. response.data [").concat(JSON.stringify(err.response.data), "]"));
            return thunkAPI.rejectWithValue((_a = err.response) === null || _a === void 0 ? void 0 : _a.data);
        }
        return thunkAPI.rejectWithValue(null);
    };
    CkUtils.parsingMenu = function (menus, withPageId) {
        if (!menus || menus.length <= 0) {
            return { menuTree: [], menuMap: {} };
        }
        var maxDepth = 0;
        var depthMenuMap = {};
        var allMenus = {};
        for (var _i = 0, menus_1 = menus; _i < menus_1.length; _i++) {
            var row = menus_1[_i];
            var name_1 = row.name;
            if (withPageId && row.rcPageName) {
                name_1 += " (".concat(row.rcPageName, ")");
            }
            allMenus[row.id] = {
                key: row.id,
                label: name_1,
                title: name_1,
                icon: row.rcIcon || '',
                order: row.listOrder,
                pid: row.parentId,
                urlpath: row.urlPath || '',
                pageid: row.rcPageName || '',
                isfirst: row.isFirstPage.toString().toLowerCase(),
                params: row.extra,
                status: row.status || DkValues_1.STATUS.ENABLE,
            };
            maxDepth = Math.max(maxDepth, row.depth);
            var depthKey = "depth".concat(row.depth);
            if (depthMenuMap[depthKey]) {
                depthMenuMap[depthKey].push(allMenus[row.id]);
            }
            else {
                depthMenuMap[depthKey] = [allMenus[row.id]];
            }
        }
        for (var depth = maxDepth; depth > 0; depth -= 1) {
            var currDepthRows = depthMenuMap["depth".concat(depth)];
            var prevDepthRows = depthMenuMap["depth".concat(depth - 1)];
            for (var _a = 0, currDepthRows_1 = currDepthRows; _a < currDepthRows_1.length; _a++) {
                var currRow = currDepthRows_1[_a];
                for (var _b = 0, prevDepthRows_1 = prevDepthRows; _b < prevDepthRows_1.length; _b++) {
                    var prevRow = prevDepthRows_1[_b];
                    if (currRow.pid === prevRow.key) {
                        if (prevRow.children) {
                            prevRow.children.push(currRow);
                        }
                        else {
                            prevRow.children = [currRow];
                        }
                    }
                }
            }
        }
        return { menuTree: depthMenuMap.depth0, menuMap: allMenus };
    };
    CkUtils.getPageMenuData = function (pageId, menuMap) {
        var menuKeys = Object.keys(menuMap);
        for (var _i = 0, menuKeys_1 = menuKeys; _i < menuKeys_1.length; _i++) {
            var row = menuKeys_1[_i];
            if (menuMap[row].pageid === pageId) {
                return menuMap[row];
            }
        }
        return undefined;
    };
    CkUtils.getBreadcrumbPath = function (pageMenuData, menuMap) {
        var paths = [pageMenuData];
        var parentKey = pageMenuData.pid || '';
        var loopCount = 0;
        while (parentKey !== '') {
            if (loopCount > 10) {
                break;
            }
            if (!menuMap[parentKey]) {
                break;
            }
            paths.push(menuMap[parentKey]);
            parentKey = menuMap[parentKey].pid || '';
            loopCount += 1;
        }
        if (paths.length > 0) {
            paths = paths.reverse();
        }
        return paths;
    };
    CkUtils.getPageMenuDataWithBreadcrumb = function (pageId, menuMap) {
        var ret = {
            menuData: undefined,
            breadcrumb: [],
        };
        ret.menuData = CkUtils.getPageMenuData(pageId, menuMap);
        if (ret.menuData) {
            ret.breadcrumb = CkUtils.getBreadcrumbPath(ret.menuData, menuMap);
        }
        return ret;
    };
    CkUtils.getSocialName = function (socialType) {
        switch (socialType) {
            case 1:
                return 'overall.google';
            case 2:
                return 'overall.naver';
            case 3:
                return 'overall.kakao';
            case 4:
                return 'overall.apple';
            case 5:
                return 'overall.instagram';
            case 6:
                return 'overall.facebook';
            default:
                return 'overall.na';
        }
    };
    CkUtils.getCustomBreadcrumbItem = function (pageTitle, pageId) {
        return {
            key: DkValues_1.CUSTOM_BREADCRUMB_PAGE_KEY,
            label: pageTitle,
            title: pageTitle,
            icon: '',
            order: 0,
            urlpath: '',
            pageid: pageId || '',
        };
    };
    CkUtils.getLocaleForJsonEditor = function (langCode) {
        var code = langCode.replace(/_/gi, '-');
        var codeArr = code.split('-');
        if (codeArr[0] === 'en' || codeArr[0] === 'es' || codeArr[0] === 'tr' || codeArr[0] === 'ja'
            || codeArr[0] === 'de' || codeArr[0] === 'ru' || codeArr[0] === 'ko') {
            return codeArr[0];
        }
        return code;
    };
    return CkUtils;
}());
exports.default = CkUtils;
