/* eslint-disable import/no-extraneous-dependencies */
/**
 * react-intersection-observer 의 hook sample 용으로 그대로 둔다. withInfiniteScrollView 함수 호출 할때 opt 값을 주면 된다.
 * 함수를 hook 할때 이런 식으로 처리 하면 된다.
 */
import React from 'react';
import { useInView } from 'react-intersection-observer';
import type { IntersectionOptions } from 'react-intersection-observer';

const withInfiniteScrollView = (Component: any, opts: IntersectionOptions) => (props: any) => {
    const { ref, inView } = useInView(opts);
    return <Component {...props} infiniteRef={ref} infiniteInView={inView}/>;
};

export default withInfiniteScrollView;
