/* eslint-disable import/no-extraneous-dependencies */
/**
 * react-router-dom 의 useNavigate 는 함수형으로만 hook 을 사용 할 수 있기 때문에
 * class 형태로 사용하기 위해서 wrapping 함.
 */
import React from 'react';
import { useNavigate, useLocation, useParams } from 'react-router-dom';

const withNavigate = (Component: any) => (props: any) => {
    // hook 은 function 내부에서 선언해야 함.
    const navigate = useNavigate();
    const location = useLocation();
    const params = useParams();
    const nprops = { ...props, ...params };
    return <Component {...nprops } navigate={navigate} location={location}/>;
};

export default withNavigate;
