/* eslint-disable import/no-extraneous-dependencies */
/**
 * react-timer-hook 의 userTimer hook 을 class 에서도 사용하기 위해서 wrapping 함.
 */
import React from 'react';
import { useTimer } from 'react-timer-hook';

const withTimerHook = (Component: any, expiryTimestamp: Date, autoStart?: boolean, onExpire?: () => void) => (props: any) => {
    // hook 은 function 내부에서 선언해야 함.
    const timer = useTimer({ expiryTimestamp, autoStart, onExpire });
    return <Component { ...props } timer={timer} />;
};

export default withTimerHook;
