"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
/* eslint-disable import/no-extraneous-dependencies */
/**
 * react-router-dom 의 useNavigate 는 함수형으로만 hook 을 사용 할 수 있기 때문에
 * class 형태로 사용하기 위해서 wrapping 함.
 */
var react_1 = __importDefault(require("react"));
var react_router_dom_1 = require("react-router-dom");
var withNavigate = function (Component) { return function (props) {
    // hook 은 function 내부에서 선언해야 함.
    var navigate = (0, react_router_dom_1.useNavigate)();
    var location = (0, react_router_dom_1.useLocation)();
    var params = (0, react_router_dom_1.useParams)();
    var nprops = __assign(__assign({}, props), params);
    return react_1.default.createElement(Component, __assign({}, nprops, { navigate: navigate, location: location }));
}; };
exports.default = withNavigate;
