import React from 'react';
import type { IntlShape } from 'react-intl';
/**
 * rest api 호출시 에러를 처리 하기 위한 공통 함수를 hook 한다.
 * 본 hook 을 포함하면 navigate 를 무조건 포함하게 된다.
 * 즉, withNavigate hook 도 같이 포함 시킨다.
 *
 * @param Component {any} hook 할 컴포넌트
 * @returns {any} intl, navigate, rest api 공통 에러 힘수를 포함한 component
 */
declare const withRestApi: (Component: any) => (props: any) => React.JSX.Element;
export default withRestApi;
export interface IsApiErrorFunction {
    (resp: any, intl: IntlShape, errMsgId?: string, movePage?: any): boolean;
}
